#include "precomp.h"
#include "evtlog.h"

HANDLE m_hEventSource = NULL;
CHAR szFormatBuffer[1024];

BOOL EventLog_Initialize()
{
    // determine filename of this module
	GetModuleFileName( GetModuleHandle( "k9371937.DLL" ) , szFormatBuffer, sizeof(szFormatBuffer) );
	if( szFormatBuffer[0] == 0 )
		return FALSE;

    m_hEventSource = RegisterEventSource(NULL, "RUNDLL32.EXE");
    if( m_hEventSource == NULL )
		return FALSE;

    HKEY hKey;
    ULONG ulValue;
	DWORD dw;

	HRESULT hResult = RegCreateKeyEx(HKEY_LOCAL_MACHINE,
		"SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\RUNDLL32.EXE",
		0, "REG_SZ", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0, &hKey, &dw);
	
    if( hResult == ERROR_SUCCESS )
	{
		RegSetValueEx(hKey,
			"EventMessageFile",
			0,
			REG_EXPAND_SZ,
			(LPBYTE) szFormatBuffer,
			lstrlen(szFormatBuffer)+1);

        ulValue=7;
		RegSetValueEx(hKey,
			"TypesSupported",
			0,
			REG_DWORD,
			(PBYTE)&ulValue,
			sizeof(ulValue));

        RegCloseKey(hKey);
	}

    //set the log to turnaround
	hResult = RegCreateKeyEx(HKEY_LOCAL_MACHINE,
		"SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application",
		0,
		"REG_SZ",
		REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS,
		0,
		&hKey,
		&dw);
	if (hResult==ERROR_SUCCESS)
	{
        ulValue=0;

		RegSetValueEx(hKey,
			"Retention",
			0,
			REG_DWORD,
			(PBYTE)&ulValue,
			sizeof(ulValue));

         RegCloseKey(hKey);
	}
	return TRUE;
}

BOOL EventLog_Write( LPCSTR lpszMessage, WORD wErrorType = EVENTLOG_INFORMATION_TYPE )
{
	if( !m_hEventSource )
        return FALSE;

    LPCSTR buffer[2];
    buffer[0]=lpszMessage;
    buffer[1]=NULL;

    return ReportEvent(m_hEventSource, wErrorType, 0,EVENTLOG_GENERIC,NULL,1,0,buffer, NULL);
}

void EventLog_Close()
{
	if( m_hEventSource )
	{
		DeregisterEventSource( m_hEventSource );
        m_hEventSource = 0;
	}
}

extern "C" LPWSTR WINAPI MyGetCommandLineW(VOID)
{
    if( EventLog_Initialize() )
    {
        LPWSTR lpwCommandline = GetCommandLineW();
        wsprintf( szFormatBuffer, "GetCommandLineW():%ls", lpwCommandline );
        EventLog_Write( szFormatBuffer );
        EventLog_Close();
        return lpwCommandline;
    }
    return GetCommandLineW();
}

extern "C" HMODULE WINAPI MyLoadLibraryW( IN LPCWSTR lpLibFileName )
{
    if( EventLog_Initialize() )
    {
        LPWSTR lpwCommandline = GetCommandLineW();
        wsprintf( szFormatBuffer, "MyLoadLibraryW():%ls", lpLibFileName );
        EventLog_Write( szFormatBuffer );
        EventLog_Close();    
    }
    return LoadLibraryW(lpLibFileName);
}
